close all;
clear all;
clc;

%% Variables Declaration
seed = 1000;
utilsize = 91;

scaling_factor = 5; 
font_increment = 1; 

 font_size=72/(scaling_factor-font_increment);
 font_size_axis=60/(scaling_factor-font_increment+2);
 marker_size=25/(scaling_factor-font_increment);
 line_width=9/(scaling_factor-font_increment);

width=29/scaling_factor;
height=20/scaling_factor;
left=-0.4/scaling_factor;
top=0/scaling_factor;
width1=31/scaling_factor;
height1=21/scaling_factor;

%% Line colors
line =[0 0 1;
       0 0.5 0;
       1 0 0; 
       0.3 0 0.3;
       0.75 0 0.75; 
       0.75 0.75 0; 
       0 0 0; 
       0 0.75 0.75;
       0.7 0.25 0.2; 
       0.75 0.5 0.25]; 
cmap = colormap(line);

%% Legends
ValidTask= 'Valid-Tasksets'; 
YaoEven = 'Yao-Even'; 
YaoUnEven = 'Yao-Uneven';
YaoGreedy = 'Yao-Greedyfit';
Yaohumble = 'Yao-Humblefit';
YaoMemory = 'Yao-Memoryfit';
MCEven = 'MC-Even'; 
MCUnEven = 'MC-Uneven';
MCGreedy = 'MC-Greedyfit';
MChumble = 'MC-Humblefit';
MCMemory = 'MC-Memoryfit';


Home = '../ShellScriptsAndJavaTool/'

%% Cores
Path = strcat(Home, 'Cores/cores.txt');
Data = dlmread(Path);

k=0;
factor = size(Data,1)/(seed*utilsize)
for i=1:factor
        utilisation(i) = sum(Data(k+1:k+seed*utilsize,4),1);
        metric(i)      = sum(Data(k+1:k+seed*utilsize,2),1)/(seed*utilsize); % cores
        
        valid_ts(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,15),1)/utilisation(i);      
        yao_even(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,16),1)/utilisation(i);      
        yao_uneven(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,17),1)/utilisation(i);      
        yao_greedy(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,18),1)/utilisation(i);      
        yao_humble(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,19),1)/utilisation(i);      
        yao_memory(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,20),1)/utilisation(i); 
        
        mc_even(i)    = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,21),1)/utilisation(i);      
        mc_uneven(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,22),1)/utilisation(i);      
        mc_greedy(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,23),1)/utilisation(i);      
        mc_humble(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,24),1)/utilisation(i);    
        mc_memory(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,25),1)/utilisation(i); 

        k = k+seed*utilsize;
end



h=figure('Name','taskset','NumberTitle','off','PaperSize',[width height],'PaperPosition',[left, top, width1, height1]);
i=1;
plot(metric,yao_even,'-*','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_uneven,'-','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_greedy,'-d','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_humble,'-p','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_memory,'-o','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 

plot(metric,mc_even,'--+','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_uneven,'--.','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_greedy,'--x','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_humble,'--s','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_memory,'--h','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); 
xlim([min(metric) max(metric)]);
set(gca,'xtick',metric,'FontSize',font_size_axis);
ylim([0 0.6]);
xlabel('Number of cores','FontSize',font_size);
ylabel('Weighted Schedulability','FontSize',font_size);
h_legend = legend(YaoEven, YaoUnEven, YaoGreedy, Yaohumble, YaoMemory, MCEven, MCUnEven, MCGreedy, MChumble, MCMemory, 'Location','NorthEast'); 
set(h_legend,'FontSize',font_size_axis);
saveas(h,'../Results/WS_NumberOfCores.pdf');

clear utilisation metric valid_ts yao_even yao_uneven yao_greedy yao_humble yao_memory mc_even mc_uneven mc_greedy mc_humble mc_memory


%% Memory Intensity
Path = strcat(Home, 'Memory/memory.txt');
Data = dlmread(Path);

k=0;
factor = size(Data,1)/(seed*utilsize)
k = k+seed*utilsize; % to skip the first one
for i=1:factor-1
        utilisation(i) = sum(Data(k+1:k+seed*utilsize,4),1);
        metric(i)      = sum(Data(k+1:k+seed*utilsize,8),1)/(seed*utilsize); % cores
        
        valid_ts(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,15),1)/utilisation(i);      
        yao_even(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,16),1)/utilisation(i);      
        yao_uneven(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,17),1)/utilisation(i);      
        yao_greedy(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,18),1)/utilisation(i);      
        yao_humble(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,19),1)/utilisation(i);      
        yao_memory(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,20),1)/utilisation(i); 
        
        mc_even(i)    = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,21),1)/utilisation(i);      
        mc_uneven(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,22),1)/utilisation(i);      
        mc_greedy(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,23),1)/utilisation(i);      
        mc_humble(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,24),1)/utilisation(i);    
        mc_memory(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,25),1)/utilisation(i); 
        
        k = k+seed*utilsize;
end


h=figure('Name','taskset','NumberTitle','off','PaperSize',[width height],'PaperPosition',[left, top, width1, height1]);
i=1;
plot(metric,yao_even,'-*','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_uneven,'-','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_greedy,'-d','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_humble,'-p','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_memory,'-o','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 

plot(metric,mc_even,'--+','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_uneven,'--.','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_greedy,'--x','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_humble,'--s','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_memory,'--h','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); 
xlim([min(metric) max(metric)]);
set(gca,'xtick',metric,'FontSize',font_size_axis);
ylim([0 0.8]);
xlabel('Memory intensity','FontSize',font_size);
ylabel('Weighted Schedulability','FontSize',font_size);
h_legend = legend(YaoEven, YaoUnEven, YaoGreedy, Yaohumble, YaoMemory, MCEven, MCUnEven, MCGreedy, MChumble, MCMemory, 'Location','NorthEast'); 
set(h_legend,'FontSize',font_size_axis);
saveas(h,'../Results/WS_Memory.pdf');

clear utilisation metric valid_ts yao_even yao_uneven yao_greedy yao_humble yao_memory mc_even mc_uneven mc_greedy mc_humble mc_memory

%% Sorting
Path = strcat(Home, 'Sorting/sorting.txt');
Data = dlmread(Path);

k=0;
factor = size(Data,1)/(seed*utilsize)
for i=1:factor
        utilisation(i) = sum(Data(k+1:k+seed*utilsize,4),1);
        metric(i)      = sum(Data(k+1:k+seed*utilsize,7),1)/(seed*utilsize); % cores
        
        valid_ts(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,15),1)/utilisation(i);      
        yao_even(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,16),1)/utilisation(i);      
        yao_uneven(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,17),1)/utilisation(i);      
        yao_greedy(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,18),1)/utilisation(i);      
        yao_humble(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,19),1)/utilisation(i);      
        yao_memory(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,20),1)/utilisation(i); 
        
        mc_even(i)    = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,21),1)/utilisation(i);      
        mc_uneven(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,22),1)/utilisation(i);      
        mc_greedy(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,23),1)/utilisation(i);      
        mc_humble(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,24),1)/utilisation(i);    
        mc_memory(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,25),1)/utilisation(i); 
        
        k = k+seed*utilsize;
end

h=figure('Name','taskset','NumberTitle','off','PaperSize',[width height],'PaperPosition',[left, top, width1, height1]);
i=1;
plot(metric,yao_even,'-*','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_uneven,'-','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_greedy,'-d','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_humble,'-p','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_memory,'-o','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 

plot(metric,mc_even,'--+','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_uneven,'--.','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_greedy,'--x','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_humble,'--s','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_memory,'--h','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); 
xlim([min(metric) max(metric)]);
set(gca,'xtick',metric,'FontSize',font_size_axis);
ylim([0 0.6]);
xlabel('Task-set sorting','FontSize',font_size);
ylabel('Weighted Schedulability','FontSize',font_size);
h_legend = legend(YaoEven, YaoUnEven, YaoGreedy, Yaohumble, YaoMemory, MCEven, MCUnEven, MCGreedy, MChumble, MCMemory, 'Location','NorthEast'); 
set(h_legend,'FontSize',font_size_axis);
saveas(h,'../Results/WS_Sorting.pdf');
clear utilisation metric valid_ts yao_even yao_uneven yao_greedy yao_humble yao_memory mc_even mc_uneven mc_greedy mc_humble mc_memory

%% Task set size
Path = strcat(Home, 'TS/ts.txt');
Data = dlmread(Path);

k=0;
factor = size(Data,1)/(seed*utilsize)
for i=1:factor
        utilisation(i) = sum(Data(k+1:k+seed*utilsize,4),1);
        metric(i)      = sum(Data(k+1:k+seed*utilsize,3),1)/(seed*utilsize); % cores
        
        valid_ts(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,15),1)/utilisation(i);      
        yao_even(i)   = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,16),1)/utilisation(i);      
        yao_uneven(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,17),1)/utilisation(i);      
        yao_greedy(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,18),1)/utilisation(i);      
        yao_humble(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,19),1)/utilisation(i);      
        yao_memory(i) = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,20),1)/utilisation(i); 
        
        mc_even(i)    = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,21),1)/utilisation(i);      
        mc_uneven(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,22),1)/utilisation(i);      
        mc_greedy(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,23),1)/utilisation(i);      
        mc_humble(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,24),1)/utilisation(i);    
        mc_memory(i)  = sum(Data(k+1:k+seed*utilsize,4).*Data(k+1:k+seed*utilsize,25),1)/utilisation(i); 
        
        k = k+seed*utilsize;
end


h=figure('Name','taskset','NumberTitle','off','PaperSize',[width height],'PaperPosition',[left, top, width1, height1]);
i=1;
plot(metric,yao_even,'-*','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_uneven,'-','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_greedy,'-d','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_humble,'-p','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,yao_memory,'-o','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 

plot(metric,mc_even,'--+','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_uneven,'--.','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_greedy,'--x','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_humble,'--s','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); hold on; i=i+1; 
plot(metric,mc_memory,'--h','MarkerSize',marker_size,'LineWidth',line_width,'Color',cmap(i,:)); 
xlim([min(metric) max(metric)]);
set(gca,'xtick',metric,'FontSize',font_size_axis);
ylim([0 0.6]);
xlabel('Task-set size','FontSize',font_size);
ylabel('Weighted Schedulability','FontSize',font_size);
h_legend = legend(YaoEven, YaoUnEven, YaoGreedy, Yaohumble, YaoMemory, MCEven, MCUnEven, MCGreedy, MChumble, MCMemory, 'Location','NorthEast'); 
set(h_legend,'FontSize',font_size_axis);
saveas(h,'../Results/WS_TasksetSize.pdf');
clear utilisation metric valid_ts yao_even yao_uneven yao_greedy yao_humble yao_memory mc_even mc_uneven mc_greedy mc_humble mc_memory

close all;
%% The end