package Analysis;
import java.util.ArrayList;
import java.util.Collections;

import Common.Constants;
import Common.Enums;
import Common.Task;
import Common.Taskset;
import Common.Enums.ActionResult;

public class Multicontroller_Memoryfit 
{
	private ArrayList<Task> taskSet; 
	private int numberOfCores; 
	private ArrayList<ArrayList<Task>> partitionedTaskset;

	private Enums.ActionResult schedulable;


	private ArrayList<Integer> memoryBudgetOfEachCoreContrOne; 
	private ArrayList<Integer> memoryBudgetOfEachCoreContrTwo; 


	
	public Multicontroller_Memoryfit(Taskset ts, int noOfProcessors, int sorting_option)
	{
		numberOfCores = noOfProcessors;
		partitionedTaskset = new ArrayList<ArrayList<Task>>();

		for(int i=0; i<numberOfCores; i++)
		{
			partitionedTaskset.add(new ArrayList<Task>()); // add cores
		}

		schedulable = Enums.ActionResult.Failure; 

		memoryBudgetOfEachCoreContrOne = new ArrayList<Integer>(numberOfCores);
		memoryBudgetOfEachCoreContrTwo = new ArrayList<Integer>(numberOfCores);


		taskSet = new ArrayList<Task>(ts.GetSize()); 
		Task task = ts.GetHeadOfTheList(); 

		while(task!=null)
		{
			taskSet.add(task); 
			task = task.GetNextTask(); 
		}

		for(int i=0; i<numberOfCores; i++)
		{
			memoryBudgetOfEachCoreContrOne.add(0); 
			memoryBudgetOfEachCoreContrTwo.add(0); 
		}

		/********** Sort the given array of tasks ****************/
		if(sorting_option == 0) // sort tasks in descending order with repespect to deadlines  
		{
			Collections.sort(taskSet,Task.deadlineComparator);
		}
		else if(sorting_option == 1) // sort tasks in descending order with respect to utilisations 
		{
			Collections.sort(taskSet,Task.utilisationComparator);
		}
		else if(sorting_option == 2) // sort tasks in descending order with repespect to total memory
		{
			Collections.sort(taskSet,Task.totalMemoryComparator);
		}
		else if(sorting_option == 3) // sort tasks in descending order with repespect to total memory density
		{
			Collections.sort(taskSet,Task.totalMemorydensityComparator);
		}
		/*		else if(sorting_option == 4) // sort tasks in descending order with repespect to deadline and then total memory density
		{
			Collections.sort(taskSet,Task.deadlineComparator);
			Collections.sort(taskSet,Task.totalMemorydensityComparator);
		}
		else if(sorting_option == 5) // sorted tasks in desceinding order with respect to utilisation and then total memory density  
		{
			Collections.sort(taskSet,Task.utilisationComparator);
			Collections.sort(taskSet,Task.totalMemorydensityComparator);
		}*/
		/*********************************************************/

		FirstFitPackingAndSchedulabilityTest(); 

	}

	private void FirstFitPackingAndSchedulabilityTest() 
	{

		schedulable = Enums.ActionResult.Failure;
		int[] deltaIncrease = new int[numberOfCores];  
		int[][] budgetArray = new int[numberOfCores][2];   

		int index_increase =0, increase = 0; 

		int remainingMemoryBudgetContrOne =  Constants.totalMemoryBudget;
		int remainingMemoryBudgetContrTwo =  Constants.totalMemoryBudget;


		// First fit approach with memorycentric distribution of bandwidth
		for(Task task: taskSet)		
		{
			
			/*if(taskSet.indexOf(task)== 11 && remainingMemoryBudgetContrOne == 16270 && remainingMemoryBudgetContrTwo == 7840)
				System.out.println("Wait here: need to perform some checking");*/

			for(int i= 0; i<numberOfCores; i++)
			{
				
				partitionedTaskset.get(i).add(task); 

				if(remainingMemoryBudgetContrOne<0 || remainingMemoryBudgetContrTwo < 0 )
					System.out.println("Error in Memory fit: remainMemory budget less than zero"); 
				
				if((remainingMemoryBudgetContrOne <= 0 && task.GetM_WCET(0)>0) || (remainingMemoryBudgetContrTwo <= 0 && task.GetM_WCET(1) > 0) || new MulticontrollerAnalysis(partitionedTaskset.get(i), memoryBudgetOfEachCoreContrOne.get(i)+remainingMemoryBudgetContrOne,memoryBudgetOfEachCoreContrTwo.get(i)+remainingMemoryBudgetContrTwo, numberOfCores).GetSchedulabilityStatus() == Enums.ActionResult.Failure)
				{
					deltaIncrease[i] = -1; 
					budgetArray[i][0] = 0; 
					budgetArray[i][1] = 0; 
				}
				else
				{
					budgetArray[i] = PerformSensitivityAnalysisToGetTheMinimumBandwidthForEachController(partitionedTaskset.get(i), memoryBudgetOfEachCoreContrOne.get(i)+remainingMemoryBudgetContrOne, memoryBudgetOfEachCoreContrTwo.get(i)+remainingMemoryBudgetContrTwo); 
					deltaIncrease[i] = budgetArray[i][0] + budgetArray[i][1] - memoryBudgetOfEachCoreContrOne.get(i) - memoryBudgetOfEachCoreContrTwo.get(i); 
					
					/*if(budgetArray[i][0] < memoryBudgetOfEachCoreContrOne.get(i) || budgetArray[i][1] < memoryBudgetOfEachCoreContrTwo.get(i))
					{
						System.out.println("-->The new bandwidth with additinal task is less than the already assigned bandwidth \t"+ budgetArray[i][0] + "\t"+memoryBudgetOfEachCoreContrOne.get(i)+ "\t"+ budgetArray[i][1] + "\t"+memoryBudgetOfEachCoreContrTwo.get(i) + "\t Total difference: " + deltaIncrease[i] + " \tCore:"+i+" \t Task Index:"+ taskSet.indexOf(task));
					}
					*/
					
					/*if(deltaIncrease[i]<0)
						System.out.println("Error in deltaincrease computation"); */
				}
								
				partitionedTaskset.get(i).remove(task);
				
				if(i == numberOfCores -1)
				{
					index_increase = Integer.MAX_VALUE;
					increase = Integer.MAX_VALUE; 
					for(int j=0; j<deltaIncrease.length; j++)
					{
						if(deltaIncrease[j]!=-1 && (deltaIncrease[j] < increase))
						{
							index_increase = j; 
							increase = deltaIncrease[j]; 
						}
					}
					
					if(index_increase != Integer.MAX_VALUE && increase != Integer.MAX_VALUE)
					{
						partitionedTaskset.get(index_increase).add(task); 
						
						
						// Adding previous budget to back to remaining budget counter
						remainingMemoryBudgetContrOne += memoryBudgetOfEachCoreContrOne.get(index_increase); 
						remainingMemoryBudgetContrTwo += memoryBudgetOfEachCoreContrTwo.get(index_increase);
						
						
						// Assigning new budgets
						//memoryBudgetOfEachCoreContrOne.set(index_increase, memoryBudgetOfEachCoreContrOne.get(index_increase)+budgetArray[index_increase][0]); 
						//memoryBudgetOfEachCoreContrTwo.set(index_increase, memoryBudgetOfEachCoreContrTwo.get(index_increase)+budgetArray[index_increase][1]); 
						
						memoryBudgetOfEachCoreContrOne.set(index_increase, budgetArray[index_increase][0]); 
						memoryBudgetOfEachCoreContrTwo.set(index_increase, budgetArray[index_increase][1]); 

						
						//System.out.println("-->one: \t" + remainingMemoryBudgetContrOne + "\t Two:\t" + remainingMemoryBudgetContrTwo + "\t"+budgetArray[index_increase][0] + "\t"+memoryBudgetOfEachCoreContrOne.get(index_increase)+ "\t"+ budgetArray[index_increase][1] + "\t"+memoryBudgetOfEachCoreContrTwo.get(index_increase) + "\t Total difference: " + deltaIncrease[index_increase] + " \tCore:"+i+" \t Task Index:"+ taskSet.indexOf(task)); 

						remainingMemoryBudgetContrOne -= budgetArray[index_increase][0]; 
						remainingMemoryBudgetContrTwo -= budgetArray[index_increase][1];
						

						if(remainingMemoryBudgetContrOne < 0 || remainingMemoryBudgetContrTwo < 0 )
							System.out.println("Error in Memory fit: remaining Memory budget less than zero"); 

					}
					else 
						return; 
					
				}
				
			}
		}
		
		schedulable = Enums.ActionResult.Success;

		//System.out.print(partitionedTaskset.size()+"\t");
	}
	
	private int[] PerformSensitivityAnalysisToGetTheMinimumBandwidthForEachController(ArrayList<Task> ts, int current_MemoryBandwidthContrOne, int current_MemoryBandwidthContrTwo) // assumes that the task-set is feasible with current_MemoryBandwidth
	{
		if(ts.isEmpty())
			return new int[]{0,0} ; 

		int X = 0; 
		Enums.ActionResult status = null; 

		int beginContrOne = 0, endContrOne = current_MemoryBandwidthContrOne;
		int beginContrTwo = 0, endContrTwo = current_MemoryBandwidthContrTwo;
		int diff = Constants.MemoryBandwidthQuantization; 


		while(endContrOne - beginContrOne > diff || endContrTwo - beginContrTwo > diff )
		{
			if(endContrOne - beginContrOne > diff)
			{
				X = (int)(Math.floor(((double)beginContrOne + (double)endContrOne)/2)); 
				status = new MulticontrollerAnalysis(ts, X, endContrTwo, numberOfCores).GetSchedulabilityStatus(); 
				if( status == Enums.ActionResult.Success)
					endContrOne = X; 
				else 
					beginContrOne = X;  
			}
			
			if(endContrTwo - beginContrTwo > diff)
			{
				X = (int)(Math.floor(((double)beginContrTwo + (double)endContrTwo)/2)); 
				status = new MulticontrollerAnalysis(ts, endContrOne, X, numberOfCores).GetSchedulabilityStatus(); 
				if( status == Enums.ActionResult.Success)
					endContrTwo = X; 
				else 
					beginContrTwo = X;  
			}

		}
		
		if(endContrOne < 0 || endContrTwo < 0)
			System.out.println("Error in sensitivity analysis"); 

		return new int[]{endContrOne, endContrTwo} ;
	}
	
/*	private int[] PerformSensitivityAnalysisToGetTheMinimumBandwidthForEachController(ArrayList<Task> ts, int current_MemoryBandwidthContrOne, int current_MemoryBandwidthContrTwo) // assumes that the task-set is feasible with current_MemoryBandwidth
	{
		if(ts.isEmpty())
			return new int[]{0,0} ; 

		int X = 0; 
		Enums.ActionResult status = null; 

		int firstContrOne = 0, secondContrOne = current_MemoryBandwidthContrOne;
		int firstContrTwo = 0, secondContrTwo = current_MemoryBandwidthContrTwo;
		int diff = Constants.MemoryBandwidthQuantization; 

		while(secondContrOne - firstContrOne > diff )
		{
			X = (int)(Math.floor(((double)firstContrOne + (double)secondContrOne)/2)); 
			status = new MulticontrollerAnalysis(ts, X, secondContrTwo, numberOfCores).GetSchedulabilityStatus(); 
			if( status == Enums.ActionResult.Success)
				secondContrOne = X; 
			else 
				firstContrOne = X;  

		}

		while(secondContrTwo - firstContrTwo > diff )
		{	

			X = (int)(Math.floor(((double)firstContrTwo + (double)secondContrTwo)/2)); 
			status = new MulticontrollerAnalysis(ts, secondContrOne, X, numberOfCores).GetSchedulabilityStatus(); 
			if( status == Enums.ActionResult.Success)
				secondContrTwo = X; 
			else 
				firstContrTwo = X;  

		}
		
		int [] order_first_second = new int[]{secondContrOne, secondContrTwo}; 
		
		
		
		X = 0; 
		status = null; 
		firstContrOne = 0; 
		secondContrOne = current_MemoryBandwidthContrOne;
		firstContrTwo = 0; 
		secondContrTwo = current_MemoryBandwidthContrTwo;
		diff = Constants.MemoryBandwidthQuantization; 

		while(secondContrTwo - firstContrTwo > diff )
		{	

			X = (int)(Math.floor(((double)firstContrTwo + (double)secondContrTwo)/2)); 
			status = new MulticontrollerAnalysis(ts, secondContrOne, X, numberOfCores).GetSchedulabilityStatus(); 
			if( status == Enums.ActionResult.Success)
				secondContrTwo = X; 
			else 
				firstContrTwo = X;  
		}
		
		while(secondContrOne - firstContrOne > diff )
		{
			X = (int)(Math.floor(((double)firstContrOne + (double)secondContrOne)/2)); 
			status = new MulticontrollerAnalysis(ts, X, secondContrTwo, numberOfCores).GetSchedulabilityStatus(); 
			if( status == Enums.ActionResult.Success)
				secondContrOne = X; 
			else 
				firstContrOne = X;  
		}


		int[] order_second_first = new int[]{secondContrOne, secondContrTwo}; 	

		
		//System.out.println(order_first_second[0]+ "\t"+order_first_second[1] +"\t"+ order_second_first[0]+ "\t"+order_second_first[1] + "\t" + (order_first_second[0]+order_first_second[1] - order_second_first[0] -order_second_first[1]) );
		
		if(order_first_second[0]+order_first_second[1] < order_second_first[0]+order_second_first[1] )
			return order_first_second;
		else 
			return order_second_first;
	}
*/

	public Enums.ActionResult GetSchedulabilityStatus()
	{
		return schedulable; 
	}

		public int GetNumberOfProcessorsUsed()
	{
		return partitionedTaskset.size(); 
	}

	public ArrayList<Integer> GetBandwidthAllocationControllerOne()
	{
		return memoryBudgetOfEachCoreContrOne; 
	}
	public ArrayList<Integer> GetBandwidthAllocationControllerTwo()
	{
		return memoryBudgetOfEachCoreContrOne; 
	}

	/*public int GetBandwidthAllocationForGivenCoreForGivenController(int core, int Controller)
	{
		if(Controller == 1)
			return memoryBudgetOfEachCoreContrOne.get(core);
		else if(Controller == 2)
			return memoryBudgetOfEachCoreContrTwo.get(core);
		else
		{
			System.out.println("Wrong Controller number");
			return -1; 
		}
	}*/
}
