package Common;

import java.util.Random;


//Lower bound specified is inlcuded and upper bound specified is excluded while generating double or integers. To include upper bound in integer just add +1 in the upper limit. For the double this critarion is not very straight forwards. 
public  class RandomGeneratorUsingJavaRandomClass
{
	private long seed; 
	private Random rand; 
	private int lastValue;
	private double lastDouble;  
	
	public RandomGeneratorUsingJavaRandomClass(long seed_in)
	{
		rand = new Random(seed_in); 
		seed = seed_in; 
		lastValue = 0 ; 
		lastDouble = 0.0; 
	}
	
	public int GetNextInt()
	{
		return GetNextInt(0,Integer.MAX_VALUE);  
	}
	
	public int GetNextInt(int max)
	{
		return GetNextInt(0,max); 
	}
	
	public int GetNextInt(int min, int max)
	{
		int nextint = rand.nextInt(Integer.MAX_VALUE);
		lastValue = min + (nextint % (max - min)); 
		return lastValue; 
	}
	
	public double GetNextDouble() // This function includes 0, but excludes 1; 
	{
		return GetNextDouble(0,1); 
	}
	
	public double GetNextDoubleExcludingZero() // This function includes 0, but excludes 1; 
	{
		double nextdouble = GetNextDouble(0,1); 
		while (nextdouble == 0)
		{
			//System.out.println(nextdouble);
			nextdouble = GetNextDouble(0,1); 
			
		}
		//System.out.println(nextdouble);
		return nextdouble; 
	}
	
	public double GetNextDouble(double max)
	{
		return GetNextDouble(0,max); 
	}
	
	public double GetNextDouble(double min, double max)
	{		
		double nextdouble = rand.nextDouble();
		lastDouble = min + (nextdouble * (max - min));
		//System.out.println(nextdouble+"\t"+lastDouble); 
		return lastDouble; 
	}	
		
}

