#!/bin/sh

# Four arguments required
# i) Name of the folder 
# ii) Name of the text file to save output data
# iii) number of elements to skip 

if [ "$1" = "" ]; then
	echo "Needs to specify a directory as first argument"
	echo "Needs to specify file name as second argument"
	exit 
fi

START=$(date +%s)

mkdir $1 
cd $1
cp -r ../Common .
cp -r ../Analysis .
cp -r ../*.sh .
javac ./Common/Main.java

i=0

MemoryBandwidthQuantization=1
startRepetitions=0
endRepetitions=1000
deadlineModel=0
minT=10000
maxT=100000


for noOfProcessors in  4
do
	for noOfTasks in `expr $noOfProcessors \* 4` 
	do
		for Period in 100000
		do 
			for totalMemoryBudget in $Period
			do 	
				for sorting_option in 0 1 2 3
				do 
					for memory_intesity in 0.5
					do 
						for systemUtilisation in $(seq 0.1 0.01 1)
						do
							if test $i -ge $3
							then
								java Common.Main $noOfProcessors $noOfTasks $systemUtilisation $Period $totalMemoryBudget $sorting_option $memory_intesity $MemoryBandwidthQuantization $startRepetitions $endRepetitions $deadlineModel $minT $maxT $2 
								#echo $noOfProcessors $noOfTasks $systemUtilisation $Period $totalMemoryBudget $sorting_option $memory_intesity $MemoryBandwidthQuantization $startRepetitions $endRepetitions $deadlineModel $minT $maxT $2 
							fi
							i=$(( $i + $endRepetitions ))
						done	
					done					
				done
			done
		done
	done
done >analysis.log	

END=$(date +%s)
DIFF=$(( $END - $START ))
echo "It took $DIFF seconds" >>analysis.log
exit
